; Code by X05
; email: X05_44960@hotmail.com
; rev: 1

      .586
      .model flat, stdcall
      option casemap :none   ; case sensitive

;--------------------------------------------------------------------------------


include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
;include \masm32\include\shell32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc
;include \masm32\include\comdlg32.inc
include \masm32\include\masm32.inc
;include \masm32\include\debug.inc


includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
;includelib \masm32\lib\shell32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
;includelib \masm32\lib\comdlg32.lib


includelib \masm32\lib\masm32.lib
;includelib \masm32\lib\debug.lib

;--------------------------------------------------------------------------------

;WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
DlgProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD
ParseString4Colors		PROTO :DWORD
DRAWITEM		PROTO :DWORD

;--------------------------------------------------------------------------------

; ---------------  Macros used -------------------------------------------------

;--------------------------------------------------------------------------------

FillSolidRect MACRO dc, rect, bkcolor
    invoke SetBkColor, dc, bkcolor
    invoke ExtTextOut, dc, 0, 0, ETO_OPAQUE, rect, NULL, 0, NULL
ENDM

RGB macro red, green, blue
        xor eax, eax
        mov ah, blue
        shl eax, 8
        mov ah, green
        mov al, red
ENDM

m2m MACRO M1, M2
	push M2
	pop  M1
ENDM

    ; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM


;--------------------------------------------------------------------------------

.const


IDD_MAINDLG                  equ 174
IDC_LST1                     equ 1001
IDC_EDIT                     equ 1002
M00_Menu equ 160
M00_Exit  equ 161
M00_About equ 162


;--------------------------------------------------------------------------------

.data


;--------------------------------------------------------------------------------

; ----------------- For the main dialog Procedure -------------------------------

;--------------------------------------------------------------------------------


AppName db 'ListBoxOwnerDemo', 0

AboutMsg db 'Code By X05. X05_44960@hotmail.com',13,10,13,10,'ListBoxOwnerDemo (rev 1)',0

NEMOMsg db '{#000000#}Made by {#ff0000#}NEMO{#0000FF#}!!!!!{#FF00FF#}', 0

GugaMsg db '{#000000#}Made by {#ff0000#}guga{#0000FF#}!!!!!{#FF00FF#}',13,10,13,10,'Working at home !', 0


CommandLine dd 0
hInstance dd 0


.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke InitCommonControls
	invoke DialogBoxParam, hInstance, IDD_MAINDLG, NULL, ADDR DlgProc, NULL
	invoke ExitProcess,0

;--------------------------------------------------------------------------------

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM


	.if uMsg == WM_INITDIALOG
		
		; add text
		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_ADDSTRING, 0, ADDR NEMOMsg
		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_SETITEMDATA, 0, 11

		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_ADDSTRING, 0, ADDR NEMOMsg
		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_SETITEMDATA, 1, 0
		
	     	invoke SendDlgItemMessage, hWin, IDC_LST1, LB_ADDSTRING, 0, ADDR NEMOMsg
		invoke SendDlgItemMessage, hWin, IDC_LST1, LB_SETITEMDATA, 2, 25

		invoke SendDlgItemMessage, hWin, IDC_EDIT, WM_SETTEXT, 0, ADDR GugaMsg
				
	.elseif uMsg == WM_COMMAND

		.if wParam == M00_Exit

			invoke SendMessage, hWin, WM_CLOSE, 0, 0
                  ret
			
		.elseif wParam == M00_About

			invoke MessageBox, hWin, ADDR AboutMsg, ADDR AppName, MB_ICONINFORMATION

		.endif

    	.elseif uMsg == WM_CTLCOLOREDIT

            invoke SetTextColor, wParam, 0ff00h	;Changed to Green
            invoke SetBkColor, wParam, Black
            invoke GetStockObject, BLACK_BRUSH
            ret
		
    	.elseif uMsg == WM_DRAWITEM
		
        	invoke DRAWITEM, lParam   
		
	.elseif  uMsg == WM_MEASUREITEM
         
	.elseif  uMsg == WM_CLOSE

		invoke EndDialog,hWin, NULL
		
	.else
		mov eax, FALSE
		ret
	.endif

	mov eax, TRUE
      ret
DlgProc endP




;--------------------------------------------------------------------------------
; ---------------- Drawing Item Procedure ---------------------------------------
;--------------------------------------------------------------------------------


.data

szDWORDfmt          db '%8.8X', 0


.data?

rItemRect 			RECT <?>
rTextRect 			RECT <?>
rValueRect 			RECT <?>

dis                 DRAWITEMSTRUCT    <?> ; For WM_DRAWITEM

szBuf 				DB 1024 DUP (?)




.code

DRAWITEM proc uses edi esi ecx, param:DWORD
        
    LOCAL crSelected:COLORREF
    LOCAL crSelectedText:COLORREF
    LOCAL crNormal:COLORREF
    LOCAL crText:COLORREF
    LOCAL iItem:DWORD
    LOCAL i:DWORD
    LOCAL nBkMode:DWORD
        
    mov esi, param
    lea edi, dis
    mov ecx, sizeof dis
    rep movsb    
    
    .if ( dis.itemID == -1 )
    	ret
    .endif
    
    .if ( !dis.hdc )
    	ret
    .endif
                    
    invoke CopyRect, ADDR rItemRect, ADDR dis.rcItem
    invoke CopyRect, ADDR rTextRect, ADDR dis.rcItem
    invoke CopyRect, ADDR rValueRect, ADDR dis.rcItem
    
    ; 
    sub rTextRect.right, 60
    mov eax, rTextRect.right
    inc eax
    add rValueRect.left, eax
    
    mov eax, dis.itemID
    mov iItem, eax
    
    invoke GetSysColor, COLOR_WINDOW
    mov crNormal, eax

    invoke GetSysColor, COLOR_HIGHLIGHT
    mov crSelected, eax
    
    invoke GetSysColor, COLOR_HIGHLIGHTTEXT
    mov crSelectedText, eax

    invoke GetSysColor, COLOR_WINDOWTEXT
    mov crText, eax
        
   	invoke SetBkMode, dis.hdc, TRANSPARENT
   	mov nBkMode, eax
    
    .if ( dis.itemState & ODS_SELECTED )    ; If Selected                                            
        FillSolidRect dis.hdc, ADDR rItemRect, crSelected ; Erase Item   
    .else
        invoke SetTextColor, dis.hdc, crText              
        FillSolidRect dis.hdc, ADDR rItemRect, crNormal   
    .endif
        
    invoke RtlZeroMemory, ADDR szBuf, sizeof szBuf
    invoke SendMessage, dis.hwndItem, LB_GETTEXT, dis.itemID, ADDR szBuf		       		       		       	
    
    invoke SendMessage, dis.hwndItem, LB_GETITEMDATA, dis.itemID, 0
    mov i, eax
    
    .if ( dis.itemState & ODS_SELECTED ) 
        invoke SetTextColor, dis.hdc, crSelectedText
    .else
        .if ( !i )
            RGB 255, 0, 0 ; RED
            invoke SetTextColor, dis.hdc, eax
        .else
            invoke SetTextColor, dis.hdc, crText
        .endif

    .endif  

	Invoke 	ParseString4Colors, ADDR szBuf
        

    invoke wsprintf, ADDR szBuf, ADDR szDWORDfmt, i
    invoke StrLen, ADDR szBuf
    invoke TextOut, dis.hdc, rValueRect.left, rValueRect.top, ADDR szBuf, eax

    .if ( dis.itemState & ODS_FOCUS )
        invoke DrawFocusRect, dis.hdc, ADDR dis.rcItem
    .endif

    mov eax, 1
    ret
DRAWITEM endp

ParseString4Colors PROC pBuf:DWORD
	LOCAL 	BegTag 	:DWORD
	LOCAL 	EndTag 	:DWORD
	LOCAL 	BegTag2	:DWORD
	LOCAL 	siz 	:_SIZE

@Loopy:
	Invoke 	InString, 1, pBuf, SADD("{#")
	Dec 	Eax
	Mov 	BegTag, Eax
	Inc 	Eax
	Invoke 	InString, Eax, pBuf, SADD("#}")
	Dec 	Eax
	Mov 	EndTag, Eax
	Inc 	Eax
	Invoke 	InString, Eax, pBuf, SADD("{#")
	Dec 	Eax
	Mov 	BegTag2, Eax

	Mov 	Eax, EndTag
	Sub 	Eax, BegTag
	.If 	Eax == 8
		Mov 	Ebx, pBuf
		Add 	Ebx, BegTag
		Add 	Ebx, 2
		Mov 	BYTE PTR [Ebx+6], 0
		Invoke 	htodw, Ebx
		Ror 	Eax, 16
		Invoke 	SetTextColor, dis.hdc, Eax

		.If 	BegTag2 != 0
			Mov 	Ecx, pBuf
			Add 	Ecx, BegTag2
			Mov 	BYTE PTR [Ecx], 0

		.EndIf

		Add 	Ebx, 8
		Invoke 	StrLen, Ebx
		Push 	Eax
		.If 	BegTag2 != 0
			Mov 	Ecx, pBuf
			Add 	Ecx, BegTag2
			Mov 	BYTE PTR [Ecx], "{"

		.EndIf

		Mov 	pBuf, Ebx
		invoke 	TextOut, dis.hdc, rTextRect.left, rTextRect.top, pBuf, eax
		Pop 	Eax
		Lea 	Edi, siz
		Invoke 	GetTextExtentPoint32, dis.hdc, pBuf, Eax, Edi
		Mov 	Eax, siz.x
		Add 	rTextRect.left, Eax

		Cmp 	BegTag2, 0
		Jg 		@Loopy

	.EndIf

	Ret

ParseString4Colors EndP

end start
